Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2693)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2696)
@@ -4569,4 +6050,288 @@
                                     tmp_3d2(:,nysf-nbgp:nynf+nbgp,             &
                                     nxlf-nbgp:nxrf+nbgp)
+
+                CASE ( 'lsm_start_index_h', 'lsm_start_index_v'  )   
+                   IF ( k == 1 )                                               &
+                      READ ( 13 )  start_index_on_file
+                      
+                CASE ( 'lsm_end_index_h', 'lsm_end_index_v' )   
+                   IF ( k == 1 )                                               &
+                      READ ( 13 )  end_index_on_file
+                
+                CASE ( 't_soil_h' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( t_soil_h%var_2d ) )               &
+                         ALLOCATE( t_soil_h%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_h%ns) )
+                      READ ( 13 )  tmp_walltype_h_2d%var_2d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                              t_soil_h%var_2d,                 &
+                                              tmp_walltype_h_2d%var_2d,        &
+                                              surf_lsm_h%start_index,          & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+
+                CASE ( 't_soil_v(0)' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( t_soil_v(0)%var_2d ) )            &
+                         ALLOCATE( t_soil_v(0)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_v(0)%ns) )
+                      READ ( 13 )  tmp_walltype_v_2d(0)%var_2d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                           t_soil_v(0)%var_2d,                 &
+                                           tmp_walltype_v_2d(0)%var_2d,        &
+                                           surf_lsm_v(0)%start_index,          & 
+                                           start_index_on_file,                &
+                                           end_index_on_file,                  &
+                                           nxlc, nysc,                         &
+                                           nxlf, nxrf, nysf, nynf,             &
+                                           nys_on_file, nyn_on_file,           &
+                                           nxl_on_file,nxr_on_file )
+
+                CASE ( 't_soil_v(1)' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( t_soil_v(1)%var_2d ) )            &
+                         ALLOCATE( t_soil_v(1)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_v(1)%ns) )
+                      READ ( 13 )  tmp_walltype_v_2d(1)%var_2d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                           t_soil_v(1)%var_2d,                 &
+                                           tmp_walltype_v_2d(1)%var_2d,        &
+                                           surf_lsm_v(1)%start_index,          & 
+                                           start_index_on_file,                &
+                                           end_index_on_file,                  &
+                                           nxlc, nysc,                         &
+                                           nxlf, nxrf, nysf, nynf,             &
+                                           nys_on_file, nyn_on_file,           &
+                                           nxl_on_file,nxr_on_file )
+
+                CASE ( 't_soil_v(2)' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( t_soil_v(2)%var_2d ) )            &
+                         ALLOCATE( t_soil_v(2)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_v(2)%ns) )
+                      READ ( 13 )  tmp_walltype_v_2d(2)%var_2d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                           t_soil_v(2)%var_2d,                 &
+                                           tmp_walltype_v_2d(2)%var_2d,        &
+                                           surf_lsm_v(2)%start_index,          & 
+                                           start_index_on_file,                &
+                                           end_index_on_file,                  &
+                                           nxlc, nysc,                         &
+                                           nxlf, nxrf, nysf, nynf,             &
+                                           nys_on_file, nyn_on_file,           &
+                                           nxl_on_file,nxr_on_file )
+
+                CASE ( 't_soil_v(3)' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( t_soil_v(3)%var_2d ) )            &
+                         ALLOCATE( t_soil_v(1)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_v(3)%ns) )
+                      READ ( 13 )  tmp_walltype_v_2d(3)%var_2d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                           t_soil_v(3)%var_2d,                 &
+                                           tmp_walltype_v_2d(3)%var_2d,        &
+                                           surf_lsm_v(3)%start_index,          & 
+                                           start_index_on_file,                &
+                                           end_index_on_file,                  &
+                                           nxlc, nysc,                         &
+                                           nxlf, nxrf, nysf, nynf,             &
+                                           nys_on_file, nyn_on_file,           &
+                                           nxl_on_file,nxr_on_file )
+
+                CASE ( 'm_soil_h' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( m_soil_h%var_2d ) )               &
+                         ALLOCATE( m_soil_h%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_h%ns) )
+                      READ ( 13 )  tmp_walltype_h_2d2%var_2d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                             m_soil_h%var_2d,                  &
+                                             tmp_walltype_h_2d2%var_2d,        &
+                                             surf_lsm_h%start_index,           & 
+                                             start_index_on_file,              &
+                                             end_index_on_file,                &
+                                             nxlc, nysc,                       &
+                                             nxlf, nxrf, nysf, nynf,           &
+                                             nys_on_file, nyn_on_file,         &
+                                             nxl_on_file,nxr_on_file )
+
+                CASE ( 'm_soil_v(0)' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( m_soil_v(0)%var_2d ) )            &
+                         ALLOCATE( m_soil_v(0)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_v(0)%ns) )
+                      READ ( 13 )  tmp_walltype_v_2d2(0)%var_2d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                          m_soil_v(0)%var_2d,                  & 
+                                          tmp_walltype_v_2d2(0)%var_2d,        &
+                                          surf_lsm_v(0)%start_index,           & 
+                                          start_index_on_file,                 &
+                                          end_index_on_file,                   &
+                                          nxlc, nysc,                          &
+                                          nxlf, nxrf, nysf, nynf,              &
+                                          nys_on_file, nyn_on_file,            &
+                                          nxl_on_file,nxr_on_file )
+
+                CASE ( 'm_soil_v(1)' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( m_soil_v(1)%var_2d ) )            &
+                         ALLOCATE( m_soil_v(1)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_v(1)%ns) )
+                      READ ( 13 )  tmp_walltype_v_2d2(1)%var_2d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                          m_soil_v(1)%var_2d,                  & 
+                                          tmp_walltype_v_2d2(1)%var_2d,        &
+                                          surf_lsm_v(1)%start_index,           & 
+                                          start_index_on_file,                 &
+                                          end_index_on_file,                   &
+                                          nxlc, nysc,                          &
+                                          nxlf, nxrf, nysf, nynf,              &
+                                          nys_on_file, nyn_on_file,            &
+                                          nxl_on_file,nxr_on_file )
+
+
+                CASE ( 'm_soil_v(2)' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( m_soil_v(2)%var_2d ) )            &
+                         ALLOCATE( m_soil_v(2)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_v(2)%ns) )
+                      READ ( 13 )  tmp_walltype_v_2d2(2)%var_2d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                          m_soil_v(2)%var_2d,                  & 
+                                          tmp_walltype_v_2d2(2)%var_2d,        &
+                                          surf_lsm_v(2)%start_index,           & 
+                                          start_index_on_file,                 &
+                                          end_index_on_file,                   &
+                                          nxlc, nysc,                          &
+                                          nxlf, nxrf, nysf, nynf,              &
+                                          nys_on_file, nyn_on_file,            &
+                                          nxl_on_file,nxr_on_file )
+
+
+                CASE ( 'm_soil_v(3)' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( m_soil_v(3)%var_2d ) )            &
+                         ALLOCATE( m_soil_v(1)%var_2d(nzb_soil:nzt_soil+1,1:surf_lsm_v(3)%ns) )
+                      READ ( 13 )  tmp_walltype_v_2d2(3)%var_2d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                          m_soil_v(3)%var_2d,                  & 
+                                          tmp_walltype_v_2d2(3)%var_2d,        &
+                                          surf_lsm_v(3)%start_index,           & 
+                                          start_index_on_file,                 &
+                                          end_index_on_file,                   &
+                                          nxlc, nysc,                          &
+                                          nxlf, nxrf, nysf, nynf,              &
+                                          nys_on_file, nyn_on_file,            &
+                                          nxl_on_file,nxr_on_file )
+
+
+                CASE ( 'm_liq_h' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( m_liq_h%var_1d ) )                &
+                         ALLOCATE( m_liq_h%var_1d(1:surf_lsm_h%ns) )
+                      READ ( 13 )  tmp_walltype_h_1d%var_1d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                              m_liq_h%var_1d,                  &
+                                              tmp_walltype_h_1d%var_1d,        &
+                                              surf_lsm_h%start_index,          & 
+                                              start_index_on_file,             &
+                                              end_index_on_file,               &
+                                              nxlc, nysc,                      &
+                                              nxlf, nxrf, nysf, nynf,          &
+                                              nys_on_file, nyn_on_file,        &
+                                              nxl_on_file,nxr_on_file )
+
+
+                CASE ( 'm_liq_v(0)' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( m_liq_v(0)%var_1d ) )             &
+                         ALLOCATE( m_liq_v(0)%var_1d(1:surf_lsm_v(0)%ns) )
+                      READ ( 13 )  tmp_walltype_v_1d(0)%var_1d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                           m_liq_v(0)%var_1d,                  &
+                                           tmp_walltype_v_1d(0)%var_1d,        &
+                                           surf_lsm_v(0)%start_index,          & 
+                                           start_index_on_file,                &
+                                           end_index_on_file,                  &
+                                           nxlc, nysc,                         &
+                                           nxlf, nxrf, nysf, nynf,             &
+                                           nys_on_file, nyn_on_file,           &
+                                           nxl_on_file,nxr_on_file )
+
+
+                CASE ( 'm_liq_v(1)' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( m_liq_v(1)%var_1d ) )             &
+                         ALLOCATE( m_liq_v(1)%var_1d(1:surf_lsm_v(1)%ns) )
+                      READ ( 13 )  tmp_walltype_v_1d(1)%var_1d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                           m_liq_v(1)%var_1d,                  &
+                                           tmp_walltype_v_1d(1)%var_1d,        &
+                                           surf_lsm_v(1)%start_index,          & 
+                                           start_index_on_file,                &
+                                           end_index_on_file,                  &
+                                           nxlc, nysc,                         &
+                                           nxlf, nxrf, nysf, nynf,             &
+                                           nys_on_file, nyn_on_file,           &
+                                           nxl_on_file,nxr_on_file )
+
+
+                CASE ( 'm_liq_v(2)' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( m_liq_v(2)%var_1d ) )             &
+                         ALLOCATE( m_liq_v(2)%var_1d(1:surf_lsm_v(2)%ns) )
+                      READ ( 13 )  tmp_walltype_v_1d(2)%var_1d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                           m_liq_v(2)%var_1d,                  &
+                                           tmp_walltype_v_1d(2)%var_1d,        &
+                                           surf_lsm_v(2)%start_index,          & 
+                                           start_index_on_file,                &
+                                           end_index_on_file,                  &
+                                           nxlc, nysc,                         &
+                                           nxlf, nxrf, nysf, nynf,             &
+                                           nys_on_file, nyn_on_file,           &
+                                           nxl_on_file,nxr_on_file )
+
+                CASE ( 'm_liq_v(3)' )
+                 
+                   IF ( k == 1 )  THEN
+                      IF ( .NOT.  ALLOCATED( m_liq_v(3)%var_1d ) )             &
+                         ALLOCATE( m_liq_v(3)%var_1d(1:surf_lsm_v(3)%ns) )
+                      READ ( 13 )  tmp_walltype_v_1d(3)%var_1d
+                   ENDIF
+                   CALL surface_restore_elements(                              &
+                                           m_liq_v(3)%var_1d,                  &
+                                           tmp_walltype_v_1d(3)%var_1d,        &
+                                           surf_lsm_v(3)%start_index,          & 
+                                           start_index_on_file,                &
+                                           end_index_on_file,                  &
+                                           nxlc, nysc,                         &
+                                           nxlf, nxrf, nysf, nynf,             &
+                                           nys_on_file, nyn_on_file,           &
+                                           nxl_on_file,nxr_on_file )
 
 
@@ -4645,5 +6410,5 @@
 !--          Charnock relation is used.
              surf_lsm_h%z0(m)  = ( 0.11_wp * molecular_viscosity /             &
-                                 surf_lsm_h%us(m) )  &
+                                 surf_lsm_h%us(m) )                            &
                                + ( alpha_ch * surf_lsm_h%us(m)**2 / g )
 
